#pragma once
#include <stdint.h>

#define MSR_APIC_BASE 0x0000001B

#define MAX_CPUS 16
#define MAX_IRQS 24
#define IRQ_BASE 0x20

struct cpu {
    uint8_t id;
    uint8_t apic_id;
    uint32_t flags;
};
struct ioapic {
    uint8_t id;
    uint32_t addr;
    uint32_t base;
};

extern struct cpu *cpus[MAX_CPUS];
extern struct ioapic ioapic;
extern uint8_t irq_redirects[MAX_IRQS];

// cpu/cpu.c
void early_cpu_init();
void cpu_init();

// cpu/registers.S
void load_idt(void *);
void write_cr3(uint64_t);
uint64_t read_msr(uint32_t);
uint64_t write_msr(uint32_t msr, uint64_t value);

// cpu/acpi.c
void acpi_parse();

// cpu/apic.c
void apic_init();
void ioapic_init();