#include <stdint.h>
#include <memory.h>
#include <string.h>

// Physical address of next page
uint64_t next = 0;

void pmm_free(uint64_t page) {
    *(uint64_t *)P2V(page) = next;
    next = page;
}

uint64_t pmm_alloc() {
    if(!next) return 0;
    uint64_t page = next;
    next = *(uint64_t *)P2V(page);
    return page;
}

uint64_t pmm_calloc() {
    uint64_t page = pmm_alloc();
    memset(P2V(page), 0, PAGE_SIZE);
    return page;
}